
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Time_entriesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.create(
            {
                id: data.id || undefined,
        
        start_time: data.start_time
        ||
        null
            ,
            
        end_time: data.end_time
        ||
        null
            ,
            
        hours: data.hours
        ||
        null
            ,
            
        billable_rate: data.billable_rate
        ||
        null
            ,
            
        is_billable: data.is_billable
        ||
        false
        
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await time_entries.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await time_entries.setUser( data.user || null, {
            transaction,
        });
        
        await time_entries.setProject( data.project || null, {
            transaction,
        });
        
        await time_entries.setTask( data.task || null, {
            transaction,
        });
        

        

        

        return time_entries;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const time_entriesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                start_time: item.start_time
            ||
            null
            ,
            
                end_time: item.end_time
            ||
            null
            ,
            
                hours: item.hours
            ||
            null
            ,
            
                billable_rate: item.billable_rate
            ||
            null
            ,
            
                is_billable: item.is_billable
            ||
            false
        
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const time_entries = await db.time_entries.bulkCreate(time_entriesData, { transaction });

        // For each item created, replace relation files
        

        return time_entries;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const time_entries = await db.time_entries.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.start_time !== undefined) updatePayload.start_time = data.start_time;
        
        
        if (data.end_time !== undefined) updatePayload.end_time = data.end_time;
        
        
        if (data.hours !== undefined) updatePayload.hours = data.hours;
        
        
        if (data.billable_rate !== undefined) updatePayload.billable_rate = data.billable_rate;
        
        
        if (data.is_billable !== undefined) updatePayload.is_billable = data.is_billable;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await time_entries.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await time_entries.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await time_entries.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.project !== undefined) {
            await time_entries.setProject(
              
              data.project,
              
              { transaction }
            );
        }
        
        if (data.task !== undefined) {
            await time_entries.setTask(
              
              data.task,
              
              { transaction }
            );
        }
        

        
        

        

        return time_entries;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of time_entries) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of time_entries) {
                await record.destroy({transaction});
            }
        });


        return time_entries;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.findByPk(id, options);

        await time_entries.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await time_entries.destroy({
            transaction
        });

        return time_entries;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const time_entries = await db.time_entries.findOne(
            { where },
            { transaction },
        );

        if (!time_entries) {
            return time_entries;
        }

        const output = time_entries.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.organization = await time_entries.getOrganization({
            transaction
        });
        
        
        output.user = await time_entries.getUser({
            transaction
        });
        
        
        output.project = await time_entries.getProject({
            transaction
        });
        
        
        output.task = await time_entries.getTask({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.projects,
        as: 'project',
        
        where: filter.project ? {
          [Op.or]: [
            { id: { [Op.in]: filter.project.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.project.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tasks,
        as: 'task',
        
        where: filter.task ? {
          [Op.or]: [
            { id: { [Op.in]: filter.task.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.task.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'time_entries',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            start_time: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    end_time: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.start_timeRange) {
                const [start, end] = filter.start_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_time: {
                    ...where.start_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_time: {
                    ...where.start_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.end_timeRange) {
                const [start, end] = filter.end_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    end_time: {
                    ...where.end_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    end_time: {
                    ...where.end_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.hoursRange) {
                const [start, end] = filter.hoursRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    hours: {
                    ...where.hours,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    hours: {
                    ...where.hours,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.billable_rateRange) {
                const [start, end] = filter.billable_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    billable_rate: {
                    ...where.billable_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    billable_rate: {
                    ...where.billable_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_billable) {
                where = {
                    ...where,
                is_billable: filter.is_billable,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.time_entries.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'time_entries',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.time_entries.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

